
var
	const
		K_RIGHT = "right"
		K_LEFT = "left"
		K_UP = "up"
		K_DOWN = "down"
		K_SPACE = "space"

mob
	var
		list/keys = list()
		input_lock = 0
		jumped = 0

	proc
		// You can override the key_down and key_up procs
		// to add new commands.
		key_down(k)
			if(k == K_SPACE)
				jumped = 1

		key_up(k)
			..(k)

		// While input is locked the KeyUp/KeyDown verbs still get called
		// but they don't call the key_up/key_down procs.
		lock_input()
			input_lock += 1

		unlock_input()
			input_lock -= 1
			if(input_lock < 0)
				input_lock = 0

		clear_input(unlock_input = 1)
			if(unlock_input)
				input_lock = 0
			for(var/k in keys)
				keys[k] = 0

	// These verbs are called by the macros defined in common/keyboard.dmf
	verb
		KeyDown(k as text)
			set hidden = 1
			set instant = 1
			if(input_lock) return

			keys[k] = 1
			key_down(k)

		KeyUp(k as text)
			set hidden = 1
			set instant = 1

			keys[k] = 0
			if(input_lock) return

			key_up(k)