
var
	const
		LEFT = WEST
		RIGHT = EAST

		JUMPING = "jumping"
		STANDING = "standing"
		MOVING = "moving"

mob
	icon_state = "iso-mob"
	pwidth = 32
	pheight = 32
	pdepth = 16

	var
		vel_x = 0
		vel_y = 0
		vel_z = 0

		on_ground = 0
		on_left = 0
		on_right = 0
		on_top = 0
		on_bottom = 0

		base_state = ""

		last_x = -1
		last_y = -1
		last_z = -1

	x_bump(atom/a)
		vel_x = 0

	y_bump(atom/a)
		vel_y = 0

	z_bump(atom/a)
		vel_z = 0

	proc
		can_jump()
			return on_ground

		jump()
			vel_z = 8

		move(d)
			if(d == RIGHT)
				if(vel_x < 5)
					vel_x += 1
			else if(d == LEFT)
				if(vel_x > -5)
					vel_x -= 1
			else if(d == UP)
				if(vel_y < 5)
					vel_y += 1
			else if(d == DOWN)
				if(vel_y > -5)
					vel_y -= 1

		gravity()
			if(on_ground) return
			vel_z -= 1

		set_state()
			var/base = base_state ? "[base_state]-" : ""

			if(!on_ground)
				icon_state = base + JUMPING
			else if(vel_x == 0 && vel_y == 0)
				icon_state = base + STANDING
			else
				icon_state = base + MOVING

		movement()

			if(x != last_x || y != last_y || z != last_z)
				var/turf/t = loc
				set_pos(x * 32 - offset_x, y * 32, t ? t.pz + t.pdepth : 0, z)

			var/list/ground = get_ground()
			var/list/left = get_left()
			var/list/right = get_right()
			var/list/top = get_top()
			var/list/bottom = get_bottom()

			on_ground = ground.len
			on_left = left.len
			on_right = right.len
			on_top = top.len
			on_bottom = bottom.len

			if(keys[K_LEFT])
				dir = LEFT
				if(!on_left)
					move(LEFT)
			if(keys[K_RIGHT])
				dir = RIGHT
				if(!on_right)
					move(RIGHT)
			if(keys[K_DOWN])
				dir = SOUTH
				if(!on_bottom)
					move(DOWN)
			if(keys[K_UP])
				dir = NORTH
				if(!on_top)
					move(UP)

			slow_down()

			gravity()

			if(jumped)
				jumped = 0
				if(can_jump())
					jump()

			set_state()

			pixel_move(vel_x,vel_y,vel_z)

		slow_down()
			if(!keys[K_LEFT] && !keys[K_RIGHT])
				if(vel_x > 1)
					vel_x -= 1
				else if(vel_x < -1)
					vel_x += 1
				else
					vel_x = 0

			if(!keys[K_UP] && !keys[K_DOWN])
				if(vel_y > 1)
					vel_y -= 1
				else if(vel_y < -1)
					vel_y += 1
				else
					vel_y = 0

mob
	proc
		get_ground()
			. = list()
			for(var/atom/a in oview(2,src))
				if(!can_bump(a)) continue

				if(px + pwidth <= a.px) continue
				if(px >= a.px + a.pwidth) continue
				if(py + pheight <= a.py) continue
				if(py >= a.py + a.pheight) continue

				if(pz > a.pz + a.pdepth) continue
				. += a

		get_left()
			. = list()
			for(var/atom/a in oview(2,src))
				if(!can_bump(a)) continue

				if(pz >= a.pz + a.pdepth) continue
				if(pz + pdepth <= a.pz) continue
				if(px != a.px + a.pwidth) continue
				if(py >= a.py + a.pheight) continue
				if(py + pheight <= a.py) continue
				. += a

		get_right()
			. = list()
			for(var/atom/a in oview(2,src))
				if(!can_bump(a)) continue

				if(pz >= a.pz + a.pdepth) continue
				if(pz + pdepth <= a.pz) continue
				if(px + pwidth != a.px) continue
				if(py >= a.py + a.pheight) continue
				if(py + pheight <= a.py) continue
				. += a

		get_bottom()
			. = list()
			for(var/atom/a in oview(2,src))
				if(!can_bump(a)) continue

				if(pz >= a.pz + a.pdepth) continue
				if(pz + pdepth <= a.pz) continue
				if(py != a.py + a.pheight) continue
				if(px >= a.px + a.pwidth) continue
				if(px + pwidth <= a.px) continue
				. += a

		get_top()
			. = list()
			for(var/atom/a in oview(2,src))
				if(!can_bump(a)) continue

				if(pz >= a.pz + a.pdepth) continue
				if(pz + pdepth <= a.pz) continue
				if(py + pheight != a.py) continue
				if(px >= a.px + a.pwidth) continue
				if(px + pwidth <= a.px) continue
				. += a

